/*
 * firewall3 - 3rd OpenWrt UCI firewall implementation
 *
 *   Copyright (C) 2013 Jo-Philipp Wich <jo@mein.io>
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef __FW3_INCLUDES_H
#define __FW3_INCLUDES_H

#include "options.h"
#include "utils.h"

extern const struct fw3_option fw3_include_opts[];

void fw3_load_includes(struct fw3_state *state, struct uci_package *p, struct blob_attr *a);

void fw3_print_includes(struct fw3_state *state, enum fw3_family family,
                        bool reload);

void fw3_run_includes(struct fw3_state *state, bool reload);

static inline void fw3_free_include(struct fw3_include *include)
{
	list_del(&include->list);
	fw3_free_object(include, fw3_include_opts);
}

#endif
